/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.battle.pvp.IPvPVisitor
 *  fire.pb.battle.pvp.IPvPVisitor$Util$ComparatorRank
 *  fire.pb.battle.pvp.PvPRaceProxy
 *  mkdb.Procedure
 *  mkdb.Transaction
 *  mkdb.logs.LogList
 *  xbean.Pod
 *  xbean.PvP3RaceRole
 *  xbean.PvP3ScoreRankList
 *  xbean.PvP3ScoreRecord
 *  xtable.Properties
 *  xtable.Pvp3historyscorelist
 */
package fire.pb.battle.pvp3;

import fire.pb.battle.pvp.IPvPVisitor;
import fire.pb.battle.pvp.PvPRaceProxy;
import fire.pb.battle.pvp3.PvP3Helper;
import fire.pb.battle.pvp3.PvP3RaceProxy;
import java.util.Comparator;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.ListIterator;
import java.util.Map;
import mkdb.Procedure;
import mkdb.Transaction;
import mkdb.logs.LogList;
import xbean.Pod;
import xbean.PvP3RaceRole;
import xbean.PvP3ScoreRankList;
import xbean.PvP3ScoreRecord;
import xtable.Properties;
import xtable.Pvp3historyscorelist;

public class PvP3RankVisitor
implements IPvPVisitor {
    private final long roleId;
    private final int addScore;

    public PvP3RankVisitor(long roleId, int addScore) {
        this.roleId = roleId;
        this.addScore = addScore;
    }

    public void visit(PvPRaceProxy pvpRaceProxy) {
        PvP3RaceProxy raceProxy = (PvP3RaceProxy)pvpRaceProxy;
        if (this.roleId != 0L) {
            PvP3RankVisitor.updateHistoryRankListOfRole(raceProxy.getGrade(), this.roleId, this.addScore);
        } else {
            PvP3RankVisitor.updateHistoryRankList(raceProxy);
        }
    }

    public static void updateHistoryRankListOfRole(int grade, long roleId, int addScore) {
        if (addScore <= 0) {
            return;
        }
        int recordMax = PvP3RankVisitor.getRecordMax();
        PvP3ScoreRankList rankList = Pvp3historyscorelist.get((Integer)grade);
        if (rankList == null) {
            rankList = Pod.newPvP3ScoreRankList();
            Pvp3historyscorelist.add((Integer)grade, (PvP3ScoreRankList)rankList);
        }
        int score = addScore;
        PvP3ScoreRecord existRecord = null;
        Iterator it = rankList.getRecords().iterator();
        while (it.hasNext()) {
            PvP3ScoreRecord record = (PvP3ScoreRecord)it.next();
            if (record.getRoleid() != roleId) continue;
            it.remove();
            existRecord = record;
            score += existRecord.getScore();
            break;
        }
        if (existRecord == null) {
            String roleName = Properties.selectRolename((Long)roleId);
            existRecord = Pod.newPvP3ScoreRecord();
            existRecord.setRoleid(roleId);
            existRecord.setRolename(roleName);
        }
        existRecord.setScore(score);
        boolean isAdd = false;
        ListIterator listIt = ((LogList)rankList.getRecords()).listIterator();
        while (listIt.hasNext()) {
            PvP3ScoreRecord record = (PvP3ScoreRecord)listIt.next();
            if (score <= record.getScore()) continue;
            listIt.previous();
            listIt.add(existRecord);
            isAdd = true;
            break;
        }
        if (!isAdd) {
            rankList.getRecords().add(existRecord);
        }
        PvP3RankVisitor.resize(rankList.getRecords(), recordMax);
    }

    public static void updateHistoryRankList(PvP3RaceProxy raceProxy) {
        int recordMax = PvP3RankVisitor.getRecordMax();
        List<PvP3RaceRole> tempRoleList = PvP3RankVisitor.getCurrentRankListAndSort(raceProxy, recordMax);
        PvP3ScoreRankList rankList = Pvp3historyscorelist.get((Integer)raceProxy.getGrade());
        if (rankList == null) {
            rankList = Pod.newPvP3ScoreRankList();
            Pvp3historyscorelist.add((Integer)raceProxy.getGrade(), (PvP3ScoreRankList)rankList);
        }
        block0: for (PvP3ScoreRecord record : rankList.getRecords()) {
            Iterator<PvP3RaceRole> it = tempRoleList.iterator();
            while (it.hasNext()) {
                PvP3RaceRole r = it.next();
                if (r.getRoleid() != record.getRoleid()) continue;
                record.setScore(record.getScore() + r.getScore());
                it.remove();
                continue block0;
            }
        }
        List records = rankList.getRecords();
        for (int i = 0; i < tempRoleList.size(); ++i) {
            PvP3RaceRole raceRole = tempRoleList.get(i);
            PvP3ScoreRecord record = Pod.newPvP3ScoreRecord();
            record.setRoleid(raceRole.getRoleid());
            record.setRolename(raceRole.getName());
            record.setScore(raceRole.getScore());
            records.add(record);
        }
        tempRoleList.clear();
        PvP3RankVisitor.sort(rankList.getRecords(), PvP3RankVisitor.getCurrentRankMap(raceProxy));
        PvP3RankVisitor.resize(rankList.getRecords(), recordMax);
    }

    public static Map<Long, Integer> getCurrentRankMap(PvP3RaceProxy raceProxy) {
        HashMap<Long, Integer> rankMap = new HashMap<Long, Integer>();
        int i = 0;
        for (PvP3RaceRole raceRole : raceProxy.getXRace().getAllroles()) {
            rankMap.put(raceRole.getRoleid(), ++i);
        }
        return rankMap;
    }

    public static List<PvP3RaceRole> getCurrentRankListAndSort(PvP3RaceProxy raceProxy, int recordMax) {
        LinkedList<PvP3RaceRole> tempRoleList = new LinkedList<PvP3RaceRole>();
        List roleList = raceProxy.getXRace().getAllroles();
        int max = Math.min(recordMax, roleList.size());
        for (int i = 0; i < max; ++i) {
            tempRoleList.add((PvP3RaceRole)roleList.get(i));
        }
        return tempRoleList;
    }

    public static void sort(List<PvP3ScoreRecord> records, Map<Long, Integer> currentRankMap) {
        LinkedList<PvP3ScoreRecord> copyRankList = new LinkedList<PvP3ScoreRecord>();
        for (PvP3ScoreRecord record : records) {
            copyRankList.add(record);
        }
        records.clear();
        copyRankList.sort((Comparator<PvP3ScoreRecord>)new IPvPVisitor.Util.ComparatorRank<PvP3ScoreRecord>(currentRankMap){

            public int compare(PvP3ScoreRecord o1, PvP3ScoreRecord o2) {
                int v = o2.getScore() - o1.getScore();
                if (v == 0) {
                    v = this.compareRank(o1.getRoleid(), o2.getRoleid());
                }
                if (v == 0) {
                    v = o1.getRoleid() - o2.getRoleid() > 0L ? 1 : -1;
                }
                return v;
            }
        });
        records.addAll(copyRankList);
    }

    public static void resize(List<PvP3ScoreRecord> records, int recordMax) {
        while (records.size() > recordMax) {
            records.remove(records.size() - 1);
        }
    }

    public static void clearHistoryRankList() {
        for (final int grade : PvP3Helper.getAllRaceIds()) {
            Procedure proc = new Procedure(){

                protected boolean process() {
                    Pvp3historyscorelist.remove((Integer)grade);
                    return true;
                }
            };
            if (Transaction.current() != null) {
                Procedure.pexecuteWhileCommit((Procedure)proc);
                continue;
            }
            proc.submit();
        }
    }

    public static int getRecordMax() {
        int recordShowMax = 50;
        int recordMax = recordShowMax * 120;
        recordMax = Math.max(recordMax, 0);
        return recordMax;
    }
}

